<?php


	$currDir=dirname(__FILE__);
	include("$currDir/defaultLang.php");
	include("$currDir/language.php");
	include("$currDir/lib.php");
	@include("$currDir/hooks/Event_Management.php");
	include("$currDir/Event_Management_dml.php");

	// mm: can the current member access this page?
	$perm=getTablePermissions('Event_Management');
	if(!$perm[0]){
		echo error_message($Translation['tableAccessDenied'], false);
		echo '<script>setTimeout("window.location=\'index.php?signOut=1\'", 2000);</script>';
		exit;
	}

	$x = new DataList;
	$x->TableName = "Event_Management";

	// Fields that can be displayed in the table view
	$x->QueryFieldsTV=array(   
		"`Event_Management`.`ID`" => "ID",
		"`Event_Management`.`Coming_Soon`" => "Coming_Soon"
	);
	// mapping incoming sort by requests to actual query fields
	$x->SortFields = array(   
		1 => '`Event_Management`.`ID`',
		2 => 2
	);

	// Fields that can be displayed in the csv file
	$x->QueryFieldsCSV=array(   
		"`Event_Management`.`ID`" => "ID",
		"`Event_Management`.`Coming_Soon`" => "Coming_Soon"
	);
	// Fields that can be filtered
	$x->QueryFieldsFilters=array(   
		"`Event_Management`.`ID`" => "ID",
		"`Event_Management`.`Coming_Soon`" => "Coming Soon"
	);

	// Fields that can be quick searched
	$x->QueryFieldsQS=array(   
		"`Event_Management`.`ID`" => "ID",
		"`Event_Management`.`Coming_Soon`" => "Coming_Soon"
	);

	// Lookup fields that can be used as filterers
	$x->filterers = array();

	$x->QueryFrom="`Event_Management` ";
	$x->QueryWhere='';
	$x->QueryOrder='';

	$x->AllowSelection = 1;
	$x->HideTableView = ($perm[2]==0 ? 1 : 0);
	$x->AllowDelete = $perm[4];
	$x->AllowMassDelete = false;
	$x->AllowInsert = $perm[1];
	$x->AllowUpdate = $perm[3];
	$x->SeparateDV = 1;
	$x->AllowDeleteOfParents = 0;
	$x->AllowFilters = 1;
	$x->AllowSavingFilters = 0;
	$x->AllowSorting = 1;
	$x->AllowNavigation = 1;
	$x->AllowPrinting = 1;
	$x->AllowCSV = 1;
	$x->RecordsPerPage = 10;
	$x->QuickSearch = 1;
	$x->QuickSearchText = $Translation["quick search"];
	$x->ScriptFileName = "Event_Management_view.php";
	$x->RedirectAfterInsert = "Event_Management_view.php?SelectedID=#ID#";
	$x->TableTitle = "Event Management";
	$x->TableIcon = "resources/table_icons/calendar.png";
	$x->PrimaryKey = "`Event_Management`.`ID`";

	$x->ColWidth   = array(  150);
	$x->ColCaption = array("Coming Soon");
	$x->ColFieldName = array('Coming_Soon');
	$x->ColNumber  = array(2);

	$x->Template = 'templates/Event_Management_templateTV.html';
	$x->SelectedTemplate = 'templates/Event_Management_templateTVS.html';
	$x->ShowTableHeader = 1;
	$x->ShowRecordSlots = 0;
	$x->HighlightColor = '#FFF0C2';

	// mm: build the query based on current member's permissions
	$DisplayRecords = $_REQUEST['DisplayRecords'];
	if(!in_array($DisplayRecords, array('user', 'group'))){ $DisplayRecords = 'all'; }
	if($perm[2]==1 || ($perm[2]>1 && $DisplayRecords=='user' && !$_REQUEST['NoFilter_x'])){ // view owner only
		$x->QueryFrom.=', membership_userrecords';
		$x->QueryWhere="where `Event_Management`.`ID`=membership_userrecords.pkValue and membership_userrecords.tableName='Event_Management' and lcase(membership_userrecords.memberID)='".getLoggedMemberID()."'";
	}elseif($perm[2]==2 || ($perm[2]>2 && $DisplayRecords=='group' && !$_REQUEST['NoFilter_x'])){ // view group only
		$x->QueryFrom.=', membership_userrecords';
		$x->QueryWhere="where `Event_Management`.`ID`=membership_userrecords.pkValue and membership_userrecords.tableName='Event_Management' and membership_userrecords.groupID='".getLoggedGroupID()."'";
	}elseif($perm[2]==3){ // view all
		// no further action
	}elseif($perm[2]==0){ // view none
		$x->QueryFields = array("Not enough permissions" => "NEP");
		$x->QueryFrom = '`Event_Management`';
		$x->QueryWhere = '';
		$x->DefaultSortField = '';
	}
	// hook: Event_Management_init
	$render=TRUE;
	if(function_exists('Event_Management_init')){
		$args=array();
		$render=Event_Management_init($x, getMemberInfo(), $args);
	}

	if($render) $x->Render();

	// hook: Event_Management_header
	$headerCode='';
	if(function_exists('Event_Management_header')){
		$args=array();
		$headerCode=Event_Management_header($x->ContentType, getMemberInfo(), $args);
	}  
	if(!$headerCode){
		include_once("$currDir/header.php"); 
	}else{
		ob_start(); include_once("$currDir/header.php"); $dHeader=ob_get_contents(); ob_end_clean();
		echo str_replace('<%%HEADER%%>', $dHeader, $headerCode);
	}

	echo $x->HTML;
	// hook: Event_Management_footer
	$footerCode='';
	if(function_exists('Event_Management_footer')){
		$args=array();
		$footerCode=Event_Management_footer($x->ContentType, getMemberInfo(), $args);
	}  
	if(!$footerCode){
		include_once("$currDir/footer.php"); 
	}else{
		ob_start(); include_once("$currDir/footer.php"); $dFooter=ob_get_contents(); ob_end_clean();
		echo str_replace('<%%FOOTER%%>', $dFooter, $footerCode);
	}
?>