<?php
	// check this file's MD5 to make sure it wasn't called before
	$prevMD5=@implode('', @file(dirname(__FILE__).'/setup.md5'));
	$thisMD5=md5(@implode('', @file("./updateDB.php")));
	if($thisMD5==$prevMD5){
		$setupAlreadyRun=true;
	}else{
		// set up tables
		if(!isset($silent)){
			$silent=true;
		}

		// set up tables
		setupTable('membership_management', "create table if not exists `membership_management` (   `ID` INT unsigned not null auto_increment , primary key (`ID`), `Logo` VARCHAR(40) , `Company_Name` VARCHAR(40) not null , `Category_Type` TEXT not null , `Company_Code` VARCHAR(40) , `Registration_No` VARCHAR(40) , `licence_No` VARCHAR(40) not null , `Registration_date` DATE , `Capital` VARCHAR(40) , `permanent_Total_Workers` VARCHAR(40) , `Male` VARCHAR(40) , `Female` VARCHAR(40) , `Temporary_Total_Workers` VARCHAR(40) , `Male_workers` VARCHAR(40) , `Female_Workers` VARCHAR(40) , `region` VARCHAR(40) , `State` VARCHAR(40) not null , `Street_Number` VARCHAR(40) , `Kebele` VARCHAR(40) , `House_office_Number` VARCHAR(40) , `Posta` VARCHAR(40) , `Zip_Code` VARCHAR(40) , `Phone_No` VARCHAR(40) , `office_Phone` VARCHAR(40) not null , `Mobile_No` VARCHAR(40) , `Fax` VARCHAR(40) , `Email` VARCHAR(80) not null , `Webiste` VARCHAR(40) , `Blog` VARCHAR(40) , `Membership_Date` DATE not null , `Registration_fee` DECIMAL(10,2) default '0.00' , `RegistrationFee_Receipt_no` VARCHAR(40) , `Anual_fee` DECIMAL(10,2) default '0.00' , `Anualfee_receipt_No` DECIMAL(10,2) default '0.00' , `Payment_due_date` DATE , `CEO_FullName` VARCHAR(40) , `Gender` VARCHAR(40) , `Position` VARCHAR(40) , `Nationality` VARCHAR(40) , `Activity_Status` VARCHAR(40) , `Remark` TEXT , `Attachment` VARCHAR(40) ) CHARSET utf8", $silent);
		setupTable('Event_Management', "create table if not exists `Event_Management` (   `ID` INT unsigned not null auto_increment , primary key (`ID`), `Coming_Soon` VARCHAR(40) ) CHARSET utf8", $silent);
		setupTable('Human_Resource', "create table if not exists `Human_Resource` (   `ID` INT unsigned not null auto_increment , primary key (`ID`), `Comingsoon` VARCHAR(40) ) CHARSET utf8", $silent);


		// save MD5
		if($fp=@fopen(dirname(__FILE__).'/setup.md5', 'w')){
			fwrite($fp, $thisMD5);
			fclose($fp);
		}
	}


	function setupIndexes($tableName, $arrFields){
		if(!is_array($arrFields)){
			return false;
		}

		foreach($arrFields as $fieldName){
			if(!$res=@db_query("SHOW COLUMNS FROM `$tableName` like '$fieldName'")){
				continue;
			}
			if(!$row=@db_fetch_assoc($res)){
				continue;
			}
			if($row['Key']==''){
				@db_query("ALTER TABLE `$tableName` ADD INDEX `$fieldName` (`$fieldName`)");
			}
		}
	}


	function setupTable($tableName, $createSQL='', $silent=true, $arrAlter=''){
		global $Translation;
		ob_start();

		echo '<div style="padding: 5px; border-bottom:solid 1px silver; font-family: verdana, arial; font-size: 10px;">';

		// is there a table rename query?
		if(is_array($arrAlter)){
			$matches=array();
			if(preg_match("/ALTER TABLE `(.*)` RENAME `$tableName`/", $arrAlter[0], $matches)){
				$oldTableName=$matches[1];
			}
		}

		if($res=@db_query("select count(1) from `$tableName`")){ // table already exists
			if($row = @db_fetch_array($res)){
				echo str_replace("<TableName>", $tableName, str_replace("<NumRecords>", $row[0],$Translation["table exists"]));
				if(is_array($arrAlter)){
					echo '<br>';
					foreach($arrAlter as $alter){
						if($alter!=''){
							echo "$alter ... ";
							if(!@db_query($alter)){
								echo '<span class="label label-danger">' . $Translation['failed'] . '</span>';
								echo '<div class="text-danger">' . $Translation['mysql said'] . ' ' . db_error(db_link()) . '</div>';
							}else{
								echo '<span class="label label-success">' . $Translation['ok'] . '</span>';
							}
						}
					}
				}else{
					echo $Translation["table uptodate"];
				}
			}else{
				echo str_replace("<TableName>", $tableName, $Translation["couldnt count"]);
			}
		}else{ // given tableName doesn't exist

			if($oldTableName!=''){ // if we have a table rename query
				if($ro=@db_query("select count(1) from `$oldTableName`")){ // if old table exists, rename it.
					$renameQuery=array_shift($arrAlter); // get and remove rename query

					echo "$renameQuery ... ";
					if(!@db_query($renameQuery)){
						echo '<span class="label label-danger">' . $Translation['failed'] . '</span>';
						echo '<div class="text-danger">' . $Translation['mysql said'] . ' ' . db_error(db_link()) . '</div>';
					}else{
						echo '<span class="label label-success">' . $Translation['ok'] . '</span>';
					}

					if(is_array($arrAlter)) setupTable($tableName, $createSQL, false, $arrAlter); // execute Alter queries on renamed table ...
				}else{ // if old tableName doesn't exist (nor the new one since we're here), then just create the table.
					setupTable($tableName, $createSQL, false); // no Alter queries passed ...
				}
			}else{ // tableName doesn't exist and no rename, so just create the table
				echo str_replace("<TableName>", $tableName, $Translation["creating table"]);
				if(!@db_query($createSQL)){
					echo '<span class="label label-danger">' . $Translation['failed'] . '</span>';
					echo '<div class="text-danger">' . $Translation['mysql said'] . db_error(db_link()) . '</div>';
				}else{
					echo '<span class="label label-success">' . $Translation['ok'] . '</span>';
				}
			}
		}

		echo "</div>";

		$out=ob_get_contents();
		ob_end_clean();
		if(!$silent){
			echo $out;
		}
	}
?>